#ifndef _MYCHRO_APPPFORILE_H_
#define _MYCHRO_APPPFORILE_H_

#include "PrivateProf.h"
#include "misc.h"

#define PROFSETTOR(x,y) void set_##y(x data){settings.y=data;};
#define PROFGETTOR(x,y) x get_##y(){return settings.y;};
#define PROFACCESSOR(x,y) PROFSETTOR(x,y) PROFGETTOR(x,y)

class AppProfile : public PrivateProfile
{
public:
	typedef struct _SETTINGS {
		RECT mainRect;
		COLORREF color_hand;
		COLORREF color_dial;
		COLORREF color_dot;
		int clock_type;
		int hand_width;
		BOOL bTransparent;
		int nTransparent;
		BOOL useGdiPlus;
		BOOL friendlyGnya;
		int bezierDivide;
		LOGFONT lf;
		COLORREF color_day;
		BOOL drawDay;
		BOOL bTopmost;
		BOOL bHideWithMouse;
		BOOL bPreventScr;
		UINT nPreventScr;
		int heightForFont;
	} SETTINGS;

	AppProfile(void);
	virtual ~AppProfile(void);
	BOOL Load(void);
	BOOL Save(void);

	SETTINGS GetSettings(void) { return settings; };
	void SetSettings( SETTINGS data ) { settings = data; };

	PROFACCESSOR( RECT, mainRect )
	PROFACCESSOR( COLORREF, color_hand )
	PROFACCESSOR( COLORREF, color_dial )
	PROFACCESSOR( COLORREF, color_dot )
	PROFACCESSOR( int, clock_type )
	PROFACCESSOR( int, hand_width )
	PROFACCESSOR( BOOL, bTransparent )
	PROFACCESSOR( int, nTransparent )
	PROFACCESSOR( BOOL, useGdiPlus )
	PROFACCESSOR( BOOL, friendlyGnya )
	PROFACCESSOR( int, bezierDivide )
	PROFACCESSOR( LOGFONT, lf )
	PROFACCESSOR( COLORREF, color_day )
	PROFACCESSOR( BOOL, drawDay )
	PROFACCESSOR( BOOL, bTopmost )
	PROFACCESSOR( BOOL, bHideWithMouse )
	PROFACCESSOR( BOOL, bPreventScr )
	PROFACCESSOR( UINT, nPreventScr )
	PROFACCESSOR( int, heightForFont )

protected:
	SETTINGS settings;

	void ReadFormat( LPCTSTR lpAppName, LPCTSTR lpDefault, LPCTSTR lpKeyName, TCHAR *format, ... );
	void WriteFormat( LPCTSTR lpAppName, LPCTSTR lpDefault, LPCTSTR lpKeyName, TCHAR *format, ... );
	void ReadFont( LPCTSTR key, LOGFONT *value, LPCTSTR app = NULL );
	void WriteFont( LPCTSTR key, LOGFONT *value, LPCTSTR app = NULL );
	void RenameOldKeys(void);
};

#undef PROFACCESSOR
#undef PROFGETTOR
#undef PROFSETTOR

#endif//_MYCHRO_APPPFORILE_H_
