#ifndef _MAIN_WINDOW_H_
#define _MAIN_WINDOW_H_

#include "Window.h"
#include "AboutDlg.h"
#include "NotifyIcon.h"
#include "AppProfile.h"
#include "GnyaClockFace.h"
#include "SettingDlg.h"

class MainWindow : public Window
{
public:
	MainWindow(void);
	~MainWindow(void);

protected:
	AboutDlg *m_aboutDlg;
	SettingDlg *m_settingDlg;
	NotifyIcon notifyIcon;
	AppProfile prof;
	GnyaClockFace *gnya;

	ULONG_PTR gdiToken;
	HDC memDC;
	HBITMAP memBmp, prevBmp;
	ULONGLONG movedOut, lastMoved;
	UINT_PTR timerDraw, timerMouse;
	BOOL bHidden;
	POINT prevPos;
	BOOL sessionIsLocked;
	BOOL gnyaDeleted;
	HBRUSH backBrush;

	INT_PTR CALLBACK WndProc( UINT uMsg, WPARAM wParam, LPARAM lParam );

	BOOL Cls_OnCreate(HWND hwnd, LPCREATESTRUCT lpCreateStruct);
	void Cls_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify);
	void Cls_OnClose(HWND hwnd);
	void Cls_OnDestroy(HWND hwnd);
	BOOL Cls_OnTrayIconMessage( UINT mouseMsg, UINT iconId );
	void Cls_OnTaskbarCreated( void );
	void Cls_OnPaint(HWND hwnd);
	void Cls_OnSize(HWND hwnd, UINT state, int cx, int cy);
	void Cls_OnRButtonUp(HWND hwnd, int x, int y, UINT keyFlags);
	void Cls_OnLButtonDown(HWND hwnd, BOOL fDoubleClick, int x, int y, UINT keyFlags);
	void Cls_OnTimer(HWND hwnd, UINT id);
	void Cls_OnMove(HWND hwnd, int x, int y);
	void Cls_OnSizing(HWND hwnd, UINT fwSide, LPRECT pRect );

	void Cmd_OnMenuAbout(void);
	void Cmd_OnMenuSetting(void);

	BOOL CreateMemDC( HDC hdc );
	void DeleteMemDC(void);
	void DrawClock( HDC hdc );
	void SetWindowState(void);
	void ProcessPopup( HWND hwnd, int x, int y );
};

#endif//_MAIN_WINDOW_H_
